import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Dictionary;
import java.util.Hashtable;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSlider;
import javax.swing.JTextField;
import javax.swing.SwingConstants;
import javax.swing.border.BevelBorder;
import javax.swing.border.Border;
import javax.swing.border.CompoundBorder;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

public class AnimationFrame2D extends JFrame{

    int sizeX = 850;
    int sizeY = 700;
    AnimationPanel2D panel;
    JTextField velocityField;
    JTextField noiseField;
    JTextField radiusField;
    Thread t;

    public AnimationFrame2D()
    {
    	setTitle("Vicsek Animation");
    	setSize(sizeX,sizeY);
	
    	// ******************************************
    	// creates animation panel
    	panel = new AnimationPanel2D(sizeX,sizeY);

    	// adds animation panel to frame
    	add(panel,BorderLayout.CENTER);
    	// *******************************************


    	// *******************************************
    	// creates panel for the start Buttons
    	JPanel startPanel = new JPanel();

    	// creates the start Button
    	JButton startButton = new JButton("Continue");

    	// creates a restart Button
    	JButton restartButton = new JButton("Restart");

    	// creates the stop Button
    	JButton stopButton = new JButton("Stop");
	
    	// registers buttons with actions
    	startActionListener startAction = new startActionListener();
    	startButton.addActionListener(startAction);
	
    	restartActionListener restartAction = new restartActionListener();
    	restartButton.addActionListener(restartAction);

    	stopActionListener stopAction = new stopActionListener();
    	stopButton.addActionListener(stopAction);
	
    	// adds buttons to start panel and to button group
    	startPanel.add(startButton);
    	startPanel.add(restartButton);
    	startPanel.add(stopButton);

    	// adds start panel to frame
    	add(startPanel,BorderLayout.SOUTH);
    	// ***********************************************
	
    	// Creates labels for sliders
    	Dictionary<Integer,Component> table = new Hashtable<Integer,Component>();
	
    	table.put(0,new JLabel("0.0"));
    	table.put(200,new JLabel("0.2"));
    	table.put(400,new JLabel("0.4"));
    	table.put(600,new JLabel("0.6"));
    	table.put(800,new JLabel("0.8"));
    	table.put(1000, new JLabel("1.0"));
    	
    	// creates border for slider panels
    	Border border1 = BorderFactory.createEmptyBorder(10, 10, 10, 10);
    	Border border2 = BorderFactory.createBevelBorder(BevelBorder.LOWERED);
    	CompoundBorder border = new CompoundBorder(border2,border1);
	
    	// ***********************************************
    	// creates panel for velocity 	
    	JPanel velocityPanel = new JPanel();
    	velocityPanel.setLayout(new BorderLayout());
    	velocityPanel.setBorder(border);

    	int i = (int)(1000*panel.getVelocity());
    	JSlider velocitySlider = new JSlider(SwingConstants.VERTICAL,0,1000,i);
    	velocitySlider.setMajorTickSpacing(200);
    	velocitySlider.setMinorTickSpacing(100);
    	velocitySlider.setPaintTicks(true);
    	velocitySlider.setPaintLabels(true);

    	velocitySlider.setLabelTable(table);
	
    	velocityListener vlistener = new velocityListener();
    	velocitySlider.addChangeListener(vlistener);
	
    	velocityPanel.add(new JLabel("Velocity"),BorderLayout.NORTH);
    	velocityPanel.add(new JLabel("v  "),BorderLayout.WEST);
    	velocityPanel.add(velocitySlider,BorderLayout.CENTER);

    	add(velocityPanel,BorderLayout.WEST);
		       

    	// ***********************************************
    	// creates panel for noise 	

    	JPanel noisePanel = new JPanel();
    	
    	i = (int)(1000*panel.getNoiseVicsek());
    	JSlider noiseVicsekSlider = new JSlider(0,1000,i);
    	noiseVicsekSlider.setMajorTickSpacing(200);
    	noiseVicsekSlider.setMinorTickSpacing(100);
    	noiseVicsekSlider.setPaintTicks(true);
    	noiseVicsekSlider.setPaintLabels(true);
    	noiseVicsekSlider.setBorder(border);

    	noiseVicsekSlider.setLabelTable(table);
	
    	noiseVicsekListener nVicseklistener = new noiseVicsekListener();
    	noiseVicsekSlider.addChangeListener(nVicseklistener);
    	
    	// *********************************************
    	i = (int)(1000*panel.getNoiseChate());
    	JSlider noiseChateSlider = new JSlider(0,1000,i);
    	noiseChateSlider.setMajorTickSpacing(200);
    	noiseChateSlider.setMinorTickSpacing(100);
    	noiseChateSlider.setPaintTicks(true);
    	noiseChateSlider.setPaintLabels(true);
    	noiseChateSlider.setBorder(border);

    	noiseChateSlider.setLabelTable(table);
	
    	noiseChateListener nChatelistener = new noiseChateListener();
    	noiseChateSlider.addChangeListener(nChatelistener);
    	
    	noisePanel.add(new JLabel("Vicsek noise"));
    	noisePanel.add(noiseVicsekSlider);
    	noisePanel.add(new JLabel("        Chate noise"));
    	noisePanel.add(noiseChateSlider);

    	add(noisePanel,BorderLayout.NORTH);


    	// ***********************************************
    	// creates panel for radius 	

    	JPanel radiusPanel = new JPanel();
    	radiusPanel.setLayout(new BorderLayout());
    	radiusPanel.setBorder(border);

    	i = (int)(1000*panel.getRadius());
    	JSlider radiusSlider = new JSlider(SwingConstants.VERTICAL,0,1000,i);
    	radiusSlider.setMajorTickSpacing(200);
    	radiusSlider.setMinorTickSpacing(100);
    	radiusSlider.setPaintTicks(true);
    	radiusSlider.setPaintLabels(true);

    	radiusSlider.setLabelTable(table);

    	radiusListener rlistener = new radiusListener();
    	radiusSlider.addChangeListener(rlistener);
	
    	radiusPanel.add(new JLabel("Radius"),BorderLayout.NORTH);
    	radiusPanel.add(new JLabel("r "),BorderLayout.WEST);
    	radiusPanel.add(radiusSlider,BorderLayout.CENTER);

    	add(radiusPanel,BorderLayout.EAST);
    }

    class startActionListener implements ActionListener{
    	public startActionListener(){}
    	public void actionPerformed(ActionEvent event){
    		if(t == null){
    			RunAnimation r = new RunAnimation();
    			t = new Thread(r);
    			t.start();
    		}
    	}
    }

    class stopActionListener implements ActionListener{
    	public stopActionListener(){}
    	public void actionPerformed(ActionEvent event){
    		if(t != null){
    			t.stop();
    			t = null;
    		}
    	}
    }
    class restartActionListener implements ActionListener{
    	public restartActionListener(){}
    	public void actionPerformed(ActionEvent event){
    		panel.restartAnimation();
    	}
    }

    class velocityListener implements ChangeListener{
    	public void stateChanged(ChangeEvent event){
    		double v;
    		int sv;
    		JSlider slider = (JSlider) event.getSource();
    		sv = slider.getValue();

    		v = (1.0*sv)/1000.0;
    		panel.setVelocity(v);
    	}
    }
    class noiseVicsekListener implements ChangeListener{
    	public void stateChanged(ChangeEvent event){
    		double v;
    		int sv;
    		JSlider slider = (JSlider) event.getSource();
    		sv = slider.getValue();

    		v = (1.0*sv)/1000.0;
    		panel.setNoiseVicsek(v);
    	}
    }
    class noiseChateListener implements ChangeListener{
    	public void stateChanged(ChangeEvent event){
    		double v;
    		int sv;
    		JSlider slider = (JSlider) event.getSource();
    		sv = slider.getValue();

    		v = (1.0*sv)/1000.0;
    		panel.setNoiseChate(v);
    	}
    }
    class radiusListener implements ChangeListener{
    	public void stateChanged(ChangeEvent event){
    		double v;
    		int sv;
    		JSlider slider = (JSlider) event.getSource();
    		sv = slider.getValue();
    		if(sv == 0)
    			sv = 1;
    		v = (1.0*sv)/1000.0;
    		panel.setRadius(v);
    	}
    }
    // This class is to implement the thread that starts the animation
    class RunAnimation implements Runnable{
    	public RunAnimation(){}
    	public void run(){
    		panel.startAnimation();
    	}
    }
	
}
